USE AdventureWorks2012;
GO

/* Create a table using CREATE TABLE */
CREATE TABLE dbo.NewEmployee1
(
     BusinessEntityID int NOT NULL
	,LastName nvarchar(50) NOT NULL
	,FirstName nvarchar(50) NOT NULL
	,PhoneNumber Phone NULL
	,AddressLine1 nvarchar(60) NOT NULL
	,City nvarchar(30) NOT NULL
	,State nchar(3) NOT NULL
	,PostalCode nvarchar(15) NOT NULL
	,CurrentFlag Flag
);
GO
SELECT *
FROM dbo.NewEmployee1
/* Create a table using SELECT INTO */
SELECT c.FirstName
      ,c.LastName
	  ,e.JobTitle
	  ,a.AddressLine1
	  ,a.City
	  ,sp.Name AS [State/Province]
	  ,a.PostalCode
INTO dbo.NewEmployee1
FROM Person.Person AS c
    JOIN HumanResources.Employee AS e 
    ON e.BusinessEntityID = c.BusinessEntityID
    JOIN Person.BusinessEntityAddress AS bea
    ON e.BusinessEntityID = bea.BusinessEntityID
    JOIN Person.Address AS a
    ON bea.AddressID = a.AddressID
    JOIN Person.StateProvince as sp 
    ON sp.StateProvinceID = a.StateProvinceID;
GO
--Test newly created table.
SELECT *
FROM dbo.nEmployeeInfo1;

--Add columns to dbo.NewEmployee2--
CREATE TABLE dbo.NewEmployee2
    (
     BusinessEntityID int NOT NULL IDENTITY
	,LastName nvarchar(50) NOT NULL
	,FirstName nvarchar(50) NOT NULL
	,PhoneNumber Phone NULL
	,AddressLine1 nvarchar(60) NOT NULL
	,City nvarchar(30) NOT NULL
	,State nchar(3) NOT NULL
	,PostalCode nvarchar(15) NOT NULL
	,CurrentFlag Flag
    );
--Verify New Table creation
SELECT *
FROM dbo.NewEmployee2;
GO
	--ADD two new columns 
ALTER TABLE dbo.NewEmployee2
            ADD MiddleInitial NVARCHAR(3) NULL;
GO
ALTER TABLE dbo.NewEmployee2
            ADD Email NVARCHAR(100) NULL;
GO
--DROP Table
IF OBJECT_ID('dbo.NewEmployees2','U') IS NOT NULL
          DROP TABLE dbo.NewEmployee2;
GO
--Use Alter Column to modify Data Types --
ALTER TABLE dbo.NewEmployee2
ALTER COLUMN email CHAR (50) ;
GO

--Table Compression, only with Enterprise Editions--
CREATE TABLE dbo.NewEmployee3
    (
     BusinessEntityID int NOT NULL
	,LastName nvarchar(50) NOT NULL
	,FirstName nvarchar(50) NOT NULL
	,PhoneNumber phone NULL
	,AddressLine1 nvarchar(60) NOT NULL
	,City nvarchar(30) NOT NULL
	,State nchar(3) NOT NULL
	,PostalCode nvarchar(15) NOT NULL
	,Email nvarchar(50) NULL
    )
WITH (DATA_COMPRESSION = ROW);

--change to page-level compression--
ALTER TABLE dbo.NewEmployee3
REBUILD WITH (DATA_COMPRESSION = Page);
