USE AdventureWorks2014;
GO
--Set Stats I/0 to ON--
SET STATISTICS IO ON;
-- Aggregate query with a join
SELECT st.Name as Territory
      ,SUM(soh.SubTotal) AS SalesTotals
FROM Sales.SalesOrderHeader AS soh
   	 INNER JOIN Sales.SalesTerritory as st
	 ON soh.TerritoryID=st.TerritoryID
GROUP BY st.Name;
GO
--Set Stats I/0 to OFF--
SET STATISTICS IO off;

--Create a View
CREATE VIEW Sales.vQuantityByTerritory
WITH SCHEMABINDING
AS
SELECT st.Name
      ,SUM(soh.SubTotal) AS SalesTotals
	  ,COUNT_BIG(*) AS TotalRows
FROM Sales.SalesOrderHeader AS soh
	 INNER JOIN Sales.SalesTerritory as st
	 ON soh.TerritoryID=st.TerritoryID
GROUP BY st.Name;
GO

-- Index the view
CREATE UNIQUE CLUSTERED INDEX idx_cl_territory
ON Sales.vQuantityByTerritory(Name);
GO

SELECT Name as Territory
      ,SalesTotals
FROM sales.vQuantityByTerritory WITH (NOEXPAND)
--GROUP BY st.Name;
GO

--Turn off Stats and drop view
SET STATISTICS IO OFF;
DROP VIEW Sales.vQuantityByTerritory;

