USE AdventureWorks2012;
GO
--Define a Primary Key Value in a new table--
CREATE TABLE dbo.Categories
			(
			  CategoryID INT NOT NULL 
			 ,CategoryName NVARCHAR(15)  NOT NULL
			 ,Description NVARCHAR(200) NOT NULL
			 ,CONSTRAINT PK_Cat PRIMARY KEY (CategoryID)
			);
GO
--Use AlterTable to ADD a constraint--
ALTER TABLE dbo.Categories
     ADD PK_Cat1 INT PRIMARY KEY;

--Define a Primary Key Value in a new table--
CREATE TABLE dbo.Products
			(
			  ProductID INT NOT NULL IDENTITY
			 ,CategoryID INT NULL
			 ,ProductName NVARCHAR(15)  NOT NULL
			 ,Description NVARCHAR(200) NOT NULL
			 ,CONSTRAINT PK_PID PRIMARY KEY(ProductID)
			);
GO
--Query for all PK in database
SELECT *
FROM sys.key_constraints
WHERE type = 'PK';

--Use AlterTable to ADD a Foreign KEYconstraint--
ALTER TABLE dbo.Products WITH CHECK
    ADD CONSTRAINT FK_Products_Categories FOREIGN KEY(CategoryID)
    REFERENCES dbo.Categories (CategoryID)

--Query for all FK in database
SELECT *
FROM sys.foreign_keys
WHERE name = 'FK_Products_Categories';

--Use Alter Table to add a Unique Constraint
ALTER TABLE dbo.Categories
     ADD CONSTRAINT UC_CategoryName UNIQUE (CategoryName);

--Query for all Unique Contraints in database--
SELECT *
FROM sys.key_constraints
WHERE type = 'UQ';

--Default Constraint--
CREATE TABLE dbo.Products1
(
  ProductID    INT          NOT NULL IDENTITY
 ,ProductName  NVARCHAR(50) NOT NULL
 ,SupplierID   INT NOT NULL
 ,CategoryID   INT NOT NULL
 ,UnitPrice    MONEY NOT NULL 
  CONSTRAINT DF_Products_UnitPrice DEFAULT(0)
 ,discontinued BIT NOT NULL
  CONSTRAINT DF_Products_discontinued DEFAULT(0)
);

SELECT *
FROM dbo.Products1

--See all default constraints for dbo.Products1 
SELECT *
FROM sys.default_constraints
WHERE parent_object_id = OBJECT_ID('dbo.Products1');

