IF OBJECT_ID('Production.tr_ProductCategory_CategoryName', 'TR') IS NOT NULL
   DROP TRIGGER Production.tr_ProductCategory_CategoryName;
GO

CREATE TRIGGER Production.tr_ProductCategory_CategoryName
    ON Production.ProductCategory
    INSTEAD OF INSERT
    AS
    BEGIN
		  SET NOCOUNT ON;
		  IF EXISTS
		           (SELECT COUNT(*)
				    FROM inserted AS i
					JOIN Production.ProductCategory AS c
					     ON i.Name=c.Name
					GROUP BY i.Name
					HAVING COUNT(*) >1
				   )
	          BEGIN
			       THROW 50000, 'Duplicate category names not allowed', 0;
			  END;
	       ELSE
		        INSERT Production.ProductCategory (Name)
				SELECT Name
				FROM inserted;
    END;
	GO
-- Drop Trigger--
IF OBJECT_ID('Production.tr_ProductionCategories_categoryname', 'TR') IS NOT NULL
  DROP TRIGGER Production.tr_ProductionCategories_categoryname;

--Trigger to print a mesage when someone tried to update 2 field-- 
  IF EXISTS (SELECT name FROM sys.objects
      WHERE name = 'reminder' AND type = 'TR')
   DROP TRIGGER Person.reminder;
GO
CREATE TRIGGER reminder
       ON Person.Address
  AFTER UPDATE 
  AS 
  IF ( UPDATE (StateProvinceID) OR UPDATE (PostalCode) )
  BEGIN
  RAISERROR (50009, 16, 10)
  END;
  GO

-- Test the trigger.
UPDATE Person.Address
SET PostalCode = 99999
WHERE PostalCode = '12345';
GO