IF OBJECT_ID('Production.tr_ProductCategory_CategoryName', 'TR') IS NOT NULL
   DROP TRIGGER Production.tr_ProductCategory_CategoryName;
GO
CREATE TRIGGER Production.tr_ProductCategory_CategoryName
    ON Production.ProductCategory
    AFTER INSERT
	     ,UPDATE
    AS
    BEGIN
		  IF @@ROWCOUNT = 0 RETURN;
		  SET NOCOUNT ON;
		  IF EXISTS
		           (SELECT COUNT(*)
				    FROM inserted AS i
					JOIN Production.ProductCategory AS c
					     ON i.Name=c.Name
					GROUP BY i.Name
					HAVING COUNT(*) >1
				   )
	          BEGIN
			       THROW 50000, 'Duplicate category names not allowed', 0;
			  END;
    END;
	GO

--Test using INSERT to fire Trigger (Run Twice)--
INSERT INTO Production.ProductCategory (Name)
     VALUES ('TestCategory1');

--Test using UPDATE to fire Trigger--
UPDATE Production.ProductCategory
       SET Name ='Clothing'
	   WHERE Name = 'TestCategory1';

SELECT *
FROM Production.ProductCategory
