USE AdventureWorks2012;
GO
--Query to find all Customer 29825 2nd Qtr Orders--
SELECT SalesOrderID
      ,CustomerID
	  ,ShipMethodID
	  ,OrderDate
	  ,DueDate
	  ,ShipDate
FROM Sales.SalesOrderHeader as soh
WHERE CustomerID = 29825
      AND OrderDate >= '2007-04-01'
      AND OrderDate < '2007-07-01';

--Declare and set a variable--
DECLARE @custid AS INT                --1st var
       ,@orderdatefrom AS DATETIME    --2nd var
	   ,@orderdateto AS DATETIME;     --3rd var
   SET @custid = 29825;               --assign value  
   SET @orderdatefrom = '2007-04-01'; --assign value
   SET @orderdateto = '2007-07-01';   --assign value
SELECT SalesOrderID
      ,CustomerID
	  ,ShipMethodID
	  ,OrderDate
	  ,DueDate
	  ,ShipDate
FROM Sales.SalesOrderHeader as soh
WHERE CustomerID = @custid
    AND OrderDate >= @orderdatefrom
    AND OrderDate < @orderdateto;
GO
--Drop Stored Procedure--
IF OBJECT_ID('Sales.GetCustomerOrders', 'P') IS NOT NULL
    DROP PROC Sales.GetCustomerOrders;
GO

--Create a Stored Procedure 
CREATE PROC Sales.GetCustomerOrders
    @custid   AS INT,
    @orderdatefrom AS DATETIME = '19000101',
    @orderdateto   AS DATETIME = '99991231',
    @numrows  AS INT = 0 OUTPUT
AS
BEGIN
    SET NOCOUNT ON;
	SELECT SalesOrderID
      ,CustomerID
	  ,ShipMethodID
	  ,OrderDate
	  ,DueDate
	  ,ShipDate
    FROM Sales.SalesOrderHeader as soh
    WHERE CustomerID = @custid
    AND OrderDate >= @orderdatefrom
    AND OrderDate < @orderdateto;
    SET @numrows = @@ROWCOUNT;
    RETURN;
END 
GO

DECLARE @rowsreturned AS INT;
EXEC Sales.GetCustomerOrders
  @custid   = 29825,
  @orderdatefrom = '20070401',
  @orderdateto  = '20070701',
  @numrows  = @rowsreturned OUTPUT;

SELECT @rowsreturned AS "Rows Returned";
GO