USE AdventureWorks2012;
GO
--Use Concatenation & Date Time--
SELECT 
       c.FirstName+' '+c.LastName as Name
      ,LOWER(LEFT(c.FirstName,1)+c.LastName)+'@itpro.tv' as Email
	  ,GetDate()
	  ,e.JobTitle
	  ,e.HireDate
	  ,a.AddressLine1
	  ,a.City
	  ,sp.Name AS [State/Province]
	  ,a.PostalCode
FROM Person.Person AS c
    JOIN HumanResources.Employee AS e 
    ON e.BusinessEntityID = c.BusinessEntityID
    JOIN Person.BusinessEntityAddress AS bea
    ON e.BusinessEntityID = bea.BusinessEntityID
    JOIN Person.Address AS a
    ON bea.AddressID = a.AddressID
    JOIN Person.StateProvince as sp 
    ON sp.StateProvinceID = a.StateProvinceID;
GO
USE AdventureWorks2012;
Go
--Using Unique Identifiers
-- Creating a table using NEWID for uniqueidentifier data type.
CREATE TABLE dbo.Customer
(
  CustomerID uniqueidentifier NOT NULL DEFAULT newid()
 ,Company varchar(30) NOT NULL
 ,ContactName varchar(60) NOT NULL
 ,Address varchar(30) NOT NULL
 ,City varchar(30) NOT NULL
 ,StateProvince varchar(10) NULL
 ,PostalCode varchar(10) NOT NULL
 ,CountryRegion varchar(20) NOT NULL
 ,Telephone varchar(15) NOT NULL
 ,Email varchar(100) NULL
);
GO
SELECT *
FROM dbo.Customer
---- Inserting 5 rows into cust table.
INSERT dbo.customer
( CustomerID,Company,ContactName
 ,Address,City,StateProvince
 ,PostalCode,CountryRegion,Telephone,Email)
VALUES
 (NEWID(), 'Zara Larsson Fanclub', 'Ronnie Wong', 'Torikatu 33', 'Oulu', NULL,
 '90110', 'Finland', '983-443655', '983-443655')
,(NEWID(), 'Universale Importado', 'Daniel Lowrie', 'Rua do Mercado, 32', 'Resende', 'SP',
 '08737-363', 'Brasil', '(14) 555-1122', '')
,(NEWID(), 'Forever 30', 'Michael Rodrick', 'Cerrito 443', 'Buenos Aires', NULL, 
 '1011', 'Argentina', '(1) 155-5555', '(1) 235-4882')
,(NEWID(), 'Hills are Alive', 'Wes Bryan', 'Kirchgasse 9', 'Graz', NULL,
 '8110', 'Austria', '7675-3455', '7675-6426')
,(NEWID(), 'Hop Scotch Fever', 'Don Pezet', 'Rue Joseph-Bens 732', 'Bruxelles', NULL,
 'B-1181', 'Belgium', '(02) 211 34 17', '(02) 211 34 18');
GO

SELECT *
FROM dbo.Customer
