use AdventureWorks2014;
go
--Scalar Subquery: returns a single value to the outer query
SELECT p.FirstName+' '+p.LastName as SalesPerson
FROM Person.Person as p
     INNER JOIN Sales.Salesperson as sp
     ON p.BusinessEntityID=sp.BusinessEntityID
WHERE Bonus = (SELECT sp.Bonus as Bonus
               FROM sales.salesperson as sp
			   );




--Corrected Below
SELECT p.FirstName+' '+p.LastName as SalesPerson
      ,Bonus
FROM Person.Person as p
     INNER JOIN Sales.Salesperson as sp
     ON p.BusinessEntityID=sp.BusinessEntityID
WHERE Bonus = (SELECT MAX(sp.Bonus) as Bonus
               FROM sales.salesperson as sp
			   );
--Multi-Valued Subqueries
SELECT p.FirstName+' '+p.LastName as SalesPerson
      ,Bonus
FROM Person.Person as p
     INNER JOIN Sales.Salesperson as sp
     ON p.BusinessEntityID=sp.BusinessEntityID
WHERE Bonus IN (SELECT sp.Bonus as Bonus
                FROM sales.salesperson as sp
			    );