USE AdventureWorks2014;
GO
--Query to show all Category Names, Colors and Quantity
SELECT  PS.Name
	   ,P.Color
	   ,PIn.Quantity
FROM Production.Product as P
     INNER JOIN Production.ProductSubcategory PS
     ON PS.ProductSubcategoryID = P.ProductSubcategoryID
     LEFT JOIN Production.ProductInventory PIn
	 ON P.ProductID = PIn.ProductID;
GO

--PIVOT Data Colors as columns and names and quantity as rows
SELECT *
FROM (SELECT PS.Name
            ,P.Color
			,PIn.Quantity
      FROM Production.Product P
      INNER JOIN Production.ProductSubcategory PS
      ON PS.ProductSubcategoryID = P.ProductSubcategoryID
      LEFT JOIN Production.ProductInventory PIn
      ON P.ProductID = PIn.ProductID
      ) DataTable
PIVOT
     (SUM(Quantity)  --Data for the rows
      FOR Color      --Different Column Headers 
      IN ( [Black],[Blue],[Grey],[Multi],[Red]
	      ,[Silver],[Silver/Black],[White],[Yellow]
          )
      ) PivotTable;
GO
