USE AdventureWorks2014;
GO

--Correlated Query
SELECT soh.SalesOrderID
      ,soh.OrderDate
      ,MaxUnitPrice = (SELECT MAX(sod.UnitPrice)
	                   FROM Sales.SalesOrderDetail sod 
		               WHERE soh.SalesOrderID = sod.SalesOrderID)
FROM Sales.SalesOrderHeader AS soh

--Derived Tables
SELECT soh.SalesOrderID
      ,soh.OrderDate
      ,sod.max_unit_price
FROM Sales.SalesOrderHeader AS soh
JOIN
    (SELECT max_unit_price = MAX(sod.UnitPrice)
           ,SalesOrderID
     FROM Sales.SalesOrderDetail AS sod
     GROUP BY sod.SalesOrderID
    ) sod
ON sod.SalesOrderID = soh.SalesOrderID;

--CROSS APPLY Example
SELECT soh.SalesOrderID
      ,soh.OrderDate
      ,sod.max_unit_price
FROM Sales.SalesOrderHeader AS soh
CROSS APPLY
(SELECT max_unit_price = MAX(sod.UnitPrice)
       ,SumLineTotal = SUM(sod.LineTotal)
 FROM Sales.SalesOrderDetail AS sod
 WHERE soh.SalesOrderID = sod.SalesOrderID
) AS sod
