USE AdventureWorks2014;
GO
--GROUPING SETS
SELECT soh.SalesOrderID
      ,YEAR (soh.OrderDate) AS Year
FROM Sales.SalesOrderHeader as soh
GROUP BY GROUPING SETS  -- You define the groups
         (
		 (SalesOrderID, YEAR(OrderDate)), -- 1st Group
		 (SalesOrderID                 ), -- 2nd Group
		 (YEAR(OrderDate)              ), -- 3rd Group
		 (                             )  -- 4th Group
		 );
GO
--CUBE
SELECT soh.SalesOrderID
      ,YEAR (soh.OrderDate) year
	  --,Count(*) as OrderNumbers
FROM Sales.SalesOrderHeader as soh
GROUP BY CUBE (SalesOrderID, YEAR(OrderDate)); --Groups by every possible combination here
GO
--ROLLUP
SELECT st.Name as Country
      ,sp.Name as Region
	  ,a.City
	  ,Count(*) as "#Order/City"
FROM person.StateProvince as sp 
     INNER JOIN sales.SalesTerritory as st
	 ON sp.TerritoryID=st.TerritoryID
	 INNER JOIN Person.Address as a
	 ON a.StateProvinceID=sp.StateProvinceID
GROUP BY ROLLUP(st.Name, sp.Name, a.City);
GO

--ROLLUP and GROUPING
SELECT
  st.Name, GROUPING(st.Name) AS grpcountry,
  sp.Name, GROUPING(sp.Name) AS grpregion,
  a.City,  GROUPING(a.City)  AS grpcity,
  count(*) as "#Order/City"
FROM person.StateProvince as sp 
     INNER JOIN sales.SalesTerritory as st
	 ON sp.TerritoryID=st.TerritoryID
	 INNER JOIN Person.Address as a
	 ON a.StateProvinceID=sp.StateProvinceID
GROUP BY ROLLUP(st.Name,sp.Name,a.City);
GO