Use AdventureWorks2014;
GO
-- Using RANK() partitioned by locationid ordered by quantity
SELECT i.ProductID
      ,p.Name
	  ,i.LocationID
	  ,i.Quantity
      ,RANK() OVER 
              (PARTITION BY i.LocationID 
			   ORDER BY i.Quantity DESC) AS Rank
FROM Production.ProductInventory AS i 
     INNER JOIN Production.Product AS p 
     ON i.ProductID = p.ProductID
WHERE i.LocationID BETWEEN 3 AND 4
ORDER BY i.LocationID;
GO




-- Using RANK() partitioned by locationid ordered by quantity
SELECT i.ProductID, p.Name, i.LocationID, i.Quantity
    ,RANK() OVER 
    (PARTITION BY i.LocationID ORDER BY i.Quantity DESC) AS Rank
FROM Production.ProductInventory AS i 
INNER JOIN Production.Product AS p 
    ON i.ProductID = p.ProductID
WHERE i.LocationID BETWEEN 3 AND 4
ORDER BY i.LocationID;
GO

--Top 10 Employees ranked by Salary
SELECT TOP(10) BusinessEntityID, Rate, 
       RANK() OVER (ORDER BY Rate DESC) AS RankBySalary
FROM HumanResources.EmployeePayHistory AS eph1
WHERE RateChangeDate = (SELECT MAX(RateChangeDate) 
                        FROM HumanResources.EmployeePayHistory AS eph2
                        WHERE eph1.BusinessEntityID = eph2.BusinessEntityID
						)
ORDER BY BusinessEntityID;

--Top 10 Employee Rank by Salary using DENSE_RANK()
SELECT TOP(10) BusinessEntityID, Rate, 
       DENSE_RANK() OVER (ORDER BY Rate DESC) AS RankBySalary
FROM HumanResources.EmployeePayHistory AS eph1
WHERE RateChangeDate = (SELECT MAX(RateChangeDate) 
                        FROM HumanResources.EmployeePayHistory AS eph2
                        WHERE eph1.BusinessEntityID = eph2.BusinessEntityID
						)
ORDER BY BusinessEntityID;