USE AdventureWorks2012;
GO

--Example #1: Create a Synonym for a TableName
CREATE SYNONYM dbo.DEPT_HISTORY 
FOR HumanResources.EmployeeDepartmentHistory;

SELECT *
FROM dbo.DEPT_HISTORY;

--To change a synonym
DROP SYNONYM dbo.DEPT_HISTORY
 
--Example #2: Create a Synonym for a VIEW
   --Create a VIEW
CREATE VIEW TotalCustomerQtyByMonth (CustomerID,OrderDate,OrderQty)
WITH SCHEMABINDING
AS
SELECT soh.CustomerID
      ,MONTH(soh.OrderDate) Month
	  ,SUM (sod.OrderQty) Quantity
FROM Sales.SalesOrderHeader AS soh
     INNER JOIN Sales.SalesOrderDetail AS sod
	 ON soh.SalesOrderID=sod.SalesOrderID
GROUP BY soh.CustomerID,soh.OrderDate;
GO

   --Create a Synonym for the dbo.TotalCustomerQtyByMonth
CREATE SYNONYM dbo.CustQty FOR dbo.TotalCustomerQtyByMonth;
GO
   --Test the use of the Synonym
SELECT CustomerID
      ,OrderDate
	  ,OrderQty
FROM dbo.CustQty;
GO
