USE AdventureWorks2014;
GO

--USE FOR XML RAW--
SELECT p.BusinessEntityID
      ,p.PersonType
	  ,p.Title
	  ,p.FirstName
	  ,p.MiddleName
	  ,p.LastName
	  ,p.Suffix
FROM Person.Person as p
--WHERE p.BusinessEntityID = 1999
FOR XML RAW;
GO

-- VALUES DISPLAYED AS ATTRIBUTE--
USE AdventureWorks2014;
GO
SELECT p.BusinessEntityID
      ,p.PersonType
	  ,p.Title
	  ,p.FirstName
	  ,p.MiddleName
	  ,p.LastName
	  ,p.Suffix
FROM Person.Person as p
WHERE p.BusinessEntityID = 1999
FOR XML AUTO;
GO

-- VALUES DISPLAYED AS A NODE ELEMENT--
SELECT p.BusinessEntityID
      ,p.PersonType
	  ,p.Title
	  ,p.FirstName
	  ,p.MiddleName
	  ,p.LastName
	  ,p.Suffix
FROM Person.Person as p
WHERE p.BusinessEntityID = 1999
FOR XML AUTO, ELEMENTS;
GO

--CHANGE SCHEMA AND TABLE NAME--
SELECT p.BusinessEntityID
      ,p.PersonType
	  ,p.Title
	  ,p.FirstName
	  ,p.MiddleName
	  ,p.LastName
	  ,p.Suffix
FROM Person.Person as p
WHERE p.BusinessEntityID = 1999
FOR XML PATH('Person');
GO

-- COMBINE ATTRIBUTE AND NODE ELEMENT--
SELECT p.BusinessEntityID AS '@BID'
      ,p.PersonType
	  ,p.Title
	  ,p.FirstName
	  ,p.MiddleName
	  ,p.LastName
	  ,p.Suffix
FROM Person.Person as p
WHERE p.BusinessEntityID = 1999
FOR XML PATH ('Person');
GO

--Shredding XML data
SELECT *
FROM Person.Person as p
WHERE p.BusinessEntityID = 1999;

--XQuery Value
SELECT p.FirstName
      ,p.LastName
	  ,Demographics.value('declare namespace ns="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey"; (/ns:IndividualSurvey/ns:Occupation)[1]','varchar(50)') AS Occupation
	  ,Demographics.value('declare namespace ns="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey"; (/ns:IndividualSurvey/ns:Education)[1]','varchar(50)') AS Education
FROM Person.Person as p
WHERE BusinessEntityID = 1999;
GO

--XML Namespaces--
;WITH XMLNAMESPACES ('http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey' AS ns)
SELECT p.FirstName
      ,MiddleName
	  ,LastName
	  ,Demographics.value('(/ns:IndividualSurvey/ns:Occupation)[1]','varchar(50)') AS Occupation
	  ,Demographics.value('(/ns:IndividualSurvey/ns:Education)[1]','varchar(50)') AS Education
FROM Person.Person as p
WHERE BusinessEntityID = 1999;
GO
