USE AdventureWorks2014;
GO
/*Create a Stored Procedure that will return all orders 
with product info and vendorname based on category */
CREATE PROCEDURE spReturnOrderDetails
                 (@categoryname AS NVARCHAR(50)
				 ,@customerID AS INT
				 ,@OrderDatefrom AS DATETIME ='20010101'
				 ,@OrderDateto AS DATETIME='20161231'
				 )
AS
BEGIN
      SELECT soh.OrderDate
            ,sod.SalesOrderID
	        ,sod.OrderQty
	        ,pcat.Name AS Category
            ,sod.ProductID 
            ,prod.Name
	        ,v.Name as VendorName
      FROM Sales.SalesOrderHeader AS soh
      INNER JOIN 
      Sales.SalesOrderDetail AS sod
	  ON soh.SalesOrderID=sod.SalesOrderID
      INNER JOIN Production.Product AS prod
	  ON sod.ProductID=prod.ProductID
	  INNER JOIN Production.ProductSubcategory AS psub
	  ON prod.ProductSubcategoryID=psub.ProductSubcategoryID
	  INNER JOIN Production.ProductCategory AS pcat
	  ON psub.ProductCategoryID=pcat.ProductCategoryID
	  INNER JOIN Purchasing.ProductVendor AS pv
	  ON prod.ProductID=pv.ProductID
	  INNER JOIN Purchasing.Vendor AS v
	  ON pv.BusinessEntityID=v.BusinessEntityID
      WHERE pcat.Name = @categoryname
	        AND OrderDate > @OrderDatefrom
			AND OrderDate < @OrderDateto
	  RETURN;
END

--Execute the Procedure
EXEC spReturnOrderDetails 
   	 @OrderDatefrom = '20090101'
	,@OrderDateto = '20121231'
	,@categoryName = 'Clothing'
	,@customerID = '29875';
GO

DROP PROCEDURE spReturnOrderDetails