--Scalar Function--
IF OBJECT_ID('sales.fn_total', 'FN') IS NOT NULL
    DROP FUNCTION sales.fn_total
GO
CREATE FUNCTION sales.fn_total
(
  @unitprice AS MONEY,
  @qty AS INT
)
RETURNS MONEY
AS
  BEGIN
  RETURN @unitprice * @qty 
  END;
GO
--Use the sales.fn_total in query
SELECT sod.SalesOrderID
      ,sod.UnitPrice
	  ,sod.OrderQty
	  ,sales.fn_total(unitprice,OrderQty)as Total
FROM Sales.SalesOrderDetail as sod
WHERE sales.fn_total(unitprice,OrderQty) >2000


--Inline TVF 
IF OBJECT_ID('Sales.fn_filtered', 'IF') IS NOT NULL
    DROP FUNCTION Sales.fn_filtered;
GO
CREATE FUNCTION Sales.fn_filtered
(
 @lowqty AS SMALLINT,
 @highqty AS SMALLINT
)
RETURNS TABLE AS RETURN
(
 SELECT sod.SalesOrderID
	   ,sod.UnitPrice
	   ,sod.OrderQty
 FROM Sales.SalesOrderDetail as sod
 WHERE OrderQty BETWEEN @lowqty AND @highqty
); 
GO
--Test InlineTVF
SELECT SalesOrderID
      ,UnitPrice
	  ,OrderQty
FROM Sales.fn_filtered(10,20);

--Multivalued TVF--
IF OBJECT_ID('Sales.fn_filtered2', 'TF') IS NOT NULL
    DROP FUNCTION Sales.fn_filtered2;
GO
CREATE FUNCTION Sales.fn_filtered2
(
 @lowqty AS SMALLINT
,@highqty AS SMALLINT
)
RETURNS @returntable TABLE
(
 orderid  INT
,unitprice  MONEY
,qty  SMALLINT
)
AS BEGIN
  INSERT @returntable
    SELECT sod.SalesOrderID
	      ,sod.unitprice
		  ,sod.OrderQty
    FROM Sales.SalesOrderDetail as sod
    WHERE OrderQty BETWEEN @lowqty AND @highqty
RETURN END;
GO
--Test multivalued TVF
SELECT orderid, unitprice, qty
FROM Sales.fn_filtered2 (10,20);