SET STATISTICS TIME ON;
GO
SELECT soh.SalesOrderID
      ,soh.CustomerID
	  ,soh.SalesPersonID
	  ,soh.OrderDate 
FROM Sales.SalesOrderHeader as soh;
GO
SET STATISTICS TIME OFF;
GO

--More complex example
SET STATISTICS TIME ON;
--SET STATISTICS IO ON;
GO

SELECT soh.OrderDate
      ,sod.SalesOrderID
	  ,sod.OrderQty
	  ,pcat.Name AS Category
      ,sod.ProductID 
      ,prod.Name
	  ,v.Name as VendorName
FROM Sales.SalesOrderHeader AS soh
     INNER JOIN 
     Sales.SalesOrderDetail AS sod
	 ON soh.SalesOrderID=sod.SalesOrderID
     INNER JOIN Production.Product AS prod
	 ON sod.ProductID=prod.ProductID
	 INNER JOIN Production.ProductSubcategory AS psub
	 ON prod.ProductSubcategoryID=psub.ProductSubcategoryID
	 INNER JOIN Production.ProductCategory AS pcat
	 ON psub.ProductCategoryID=pcat.ProductCategoryID
	 INNER JOIN Purchasing.ProductVendor AS pv
	 ON prod.ProductID=pv.ProductID
	 INNER JOIN Purchasing.Vendor AS v
	 ON pv.BusinessEntityID=v.BusinessEntityID
GO
SET STATISTICS TIME OFF;
--SET STATISTICS IO OFF;
GO