SELECT *
FROM Sales.SalesOrderHeader

SET STATISTICS IO ON;
GO
SELECT SalesOrderID, CustomerID, SalesPersonID, OrderDate 
FROM Sales.SalesOrderHeader;
GO
SET STATISTICS IO OFF;

USE AdventureWorks2014;
GO

--Execution Plan
--Create a Query that will return all orders with product info and vendorname
SELECT soh.OrderDate
      ,sod.SalesOrderID
	  ,sod.OrderQty
	  ,pcat.Name AS Category
      ,sod.ProductID 
      ,prod.Name
	  ,v.Name as VendorName
FROM Sales.SalesOrderHeader AS soh
     INNER JOIN 
     Sales.SalesOrderDetail AS sod
	 ON soh.SalesOrderID=sod.SalesOrderID
     INNER JOIN Production.Product AS prod
	 ON sod.ProductID=prod.ProductID
	 INNER JOIN Production.ProductSubcategory AS psub
	 ON prod.ProductSubcategoryID=psub.ProductSubcategoryID
	 INNER JOIN Production.ProductCategory AS pcat
	 ON psub.ProductCategoryID=pcat.ProductCategoryID
	 INNER JOIN Purchasing.ProductVendor AS pv
	 ON prod.ProductID=pv.ProductID
	 INNER JOIN Purchasing.Vendor AS v
	 ON pv.BusinessEntityID=v.BusinessEntityID
WHERE pcat.Name = 'Clothing'