USE AdventureWorks2012;
GO

--Implicit Transactions
SET IMPLICIT_TRANSACTIONS ON;
SELECT @@TRANCOUNT; -- 0
SET IDENTITY_INSERT Production.Product ON;
-- add your DML statement here
INSERT INTO Production.Product(ProductID, Name, Color, ProductSubcategoryID,
 ListPrice, ProductLine)
    VALUES(101, 'Test2: Bad categoryid', 1, 1, 18.00, 0);
SELECT @@TRANCOUNT; -- 1
COMMIT TRAN;
SET IDENTITY_INSERT Production.Product OFF;
SET IMPLICIT_TRANSACTIONS OFF;
-- Remove the inserted row
DELETE FROM Production.Product WHERE ProductID = 980; -- Note the row is deleted

--Explicit Transaction
SELECT @@TRANCOUNT; -- 0
BEGIN TRAN;
SELECT @@TRANCOUNT; -- 1
       SET IDENTITY_INSERT Production.Product ON;
INSERT INTO  Production.Product
            (ProductID,Name,Color,ProductSubcategoryID
			,Listprice, ProductLine
			)
            VALUES(101, 'Test2: Bad categoryid', 1, 1, 18.00, 0);
          SELECT @@TRANCOUNT; -- 1
          SET IDENTITY_INSERT Production.Product OFF;
COMMIT TRAN;
      -- Remove the inserted row
      DELETE FROM Production.Product WHERE productid = 365; -- Note the row is deleted

--Nested Transaction
SELECT @@TRANCOUNT; -- = 0
BEGIN TRAN;
           SELECT @@TRANCOUNT; -- = 1
           BEGIN TRAN;
                      SELECT @@TRANCOUNT; -- = 2
             
           COMMIT
           SELECT @@TRANCOUNT; -- = 1
COMMIT TRAN;
SELECT @@TRANCOUNT; -- = 0

--Using ROLLBACK
SELECT @@TRANCOUNT; -- = 0
       BEGIN TRAN;
                  SELECT @@TRANCOUNT; -- = 1
                  BEGIN TRAN;
                             SELECT @@TRANCOUNT; -- = 2
                             -- Issue data modification or DDL command here
      ROLLBACK; -- rolls back the entire transaction at this point
SELECT @@TRANCOUNT; -- = 0