USE AdventureWorks2014;
GO

--Creating a Stored Procedure that will run through each customer in Customer table.
IF OBJECT_ID('Sales.ProcessCustomer') IS NOT NULL
  DROP PROC Sales.ProcessCustomer;
GO
CREATE PROC Sales.ProcessCustomer
(
  @customerid AS INT
)
AS
PRINT 'Processing customer ' + CAST(@customerid AS VARCHAR(10));
GO

--Using cursor 
SET NOCOUNT ON;
DECLARE @curcustid AS INT;
DECLARE cust_cursor CURSOR FAST_FORWARD FOR
   SELECT customerid
   FROM Sales.Customer;
OPEN cust_cursor;
FETCH NEXT FROM cust_cursor INTO @curcustid;
WHILE @@FETCH_STATUS = 0
BEGIN
  EXEC Sales.ProcessCustomer @customerid = @curcustid;
  FETCH NEXT FROM cust_cursor INTO @curcustid;
END;
CLOSE cust_cursor;
DEALLOCATE cust_cursor;
GO

--without Cursor
SET NOCOUNT ON;

DECLARE @curcustid AS INT;
SET @curcustid = (SELECT TOP (1) customerid
                  FROM Sales.Customer
                  ORDER BY customerid);
WHILE @curcustid IS NOT NULL
BEGIN
  EXEC Sales.ProcessCustomer @customerid = @curcustid;
  SET @curcustid = (SELECT TOP (1) customerid
                    FROM Sales.Customer
                    WHERE customerid > @curcustid
                    ORDER BY customerid
				   );
END;
GO
