--Correlated Subquery
SELECT soh.SalesOrderID, soh.OrderDate,
 (SELECT MAX(sod.UnitPrice) 
  FROM Sales.SalesOrderDetail sod 
  WHERE soh.SalesOrderID = sod.SalesOrderID) as MaxUnitPrice
FROM Sales.SalesOrderHeader AS soh;

--Derived Tables
SELECT soh.SalesOrderID,soh.OrderDate,sod.max_unit_price
FROM Sales.SalesOrderHeader AS soh
     JOIN
     (SELECT max_unit_price = MAX(sod.UnitPrice),SalesOrderID
      FROM Sales.SalesOrderDetail AS sod
      GROUP BY sod.SalesOrderID) sod
ON sod.SalesOrderID = soh.SalesOrderID

--CROSS APPLY
SELECT soh.SalesOrderID,soh.OrderDate,sod.max_unit_price as HighestPrice
--,sod.sum_line_total as Total
FROM Sales.SalesOrderHeader AS soh
  CROSS APPLY
  (SELECT max_unit_price = MAX(sod.UnitPrice) --,sum_line_total = SUM(sod.LineTotal)
   FROM Sales.SalesOrderDetail AS sod
   WHERE soh.SalesOrderID = sod.SalesOrderID) sod