/* Basic SELECT query, two columns, 5 rows */
USE AdventureWorks2014;
GO
SELECT DaysToManufacture
      ,AVG(StandardCost) AS AverageCost 
FROM Production.Product
GROUP BY DaysToManufacture;
GO




/* Pivot displaying same info with a single row, 5 columns */
SELECT 'AverageCost' AS CostSortedByProductionDays
       ,[0]
	   ,[1]
	   ,[2]
	   ,[3]
	   ,[4]
FROM  (SELECT DaysToManufacture, StandardCost 
       FROM Production.Product) AS SourceTable
PIVOT
	(AVG(StandardCost)
     FOR DaysToManufacture IN ([0], [1], [2], [3], [4])
    ) AS PivotTable;
