Use AdventureWorks2014;
GO
--XML RAW
SELECT Customer.customerid
      ,Customer.PersonID
	  ,[Order].SalesOrderID
	  ,[Order].orderdate
FROM Sales.Customer AS Customer
     INNER JOIN Sales.SalesOrderHeader AS [Order]
     ON Customer.CustomerID = [Order].CustomerID
ORDER BY Customer.CustomerID, [Order].SalesOrderID
FOR XML RAW;

--XML AUTO
WITH XMLNAMESPACES('TK461-CustomersOrders' AS co)
SELECT [co:Customer].customerID AS [co:CustomerID]
      ,[co:Customer].PersonID AS [co:PersonID]
	  ,[co:Order].SalesOrderID AS [co:SalesOrderID]
	  ,[co:Order].OrderDate AS [co:OrderDate]
FROM Sales.Customer AS [co:Customer]
     INNER JOIN Sales.SalesOrderHeader AS [co:Order]
     ON [co:Customer].CustomerID = [co:Order].CustomerID
ORDER BY [co:Customer].CustomerID, [co:Order].SalesOrderID
FOR XML AUTO, ELEMENTS, ROOT('CustomersOrders');

--XML Fragment
SELECT Customer.customerid AS [@custid]
      ,Customer.AccountNumber AS [@acctnumber]
	  ,(SELECT [Order].SalesOrderID AS [@orderid]
	          ,[Order].OrderDate AS [@orderdate]
        FROM Sales.SalesOrderHeader AS [Order]
        WHERE Customer.CustomerID = [Order].CustomerID
        AND [Order].SalesOrderID %2 = 0
        ORDER BY [Order].SalesOrderID
        FOR XML PATH('Order'), TYPE)
FROM Sales.Customer AS Customer
WHERE Customer.CustomerID <= 2
ORDER BY Customer.CustomerID
FOR XML PATH('Customer');
