Querying Microsoft SQL Server 2012 - Exam 70-461
============================================================
{FileName}microsoft-sql70461-0-0-skills_measured-MMDDYY
{EpisodeName}
{ShowName}Querying Microsoft SQL Server 2012
{Description}
*In December 2015, this exam was evaluated for applicability to both SQL Server 2012 and SQL Server 2014. It was determined that no updates to exam objectives were required.*
1.0 Create database objects (20–25%)
------------------------------------------------------------
* 1.1 Create and alter tables using T-SQL syntax (simple statements)
	+ Create tables without using the built in tools; ALTER; DROP; ALTER COLUMN; CREATE
* 1.2 Create and alter views (simple statements)
	+ Create indexed views
	+ Create views without using the built in tools; CREATE, ALTER, DROP
* 1.3 Design views
	+ Ensure code non regression by keeping consistent signature for procedure, views and function (interfaces); 
	+ security implications
* 1.4 Create and modify constraints (simple statements)
	+ Create constraints on tables; 
	+ Define constraints; 
	+ Unique constraints; 
	+ Default constraints; 
	+ Primary and foreign key constraints
* 1.5 Create and alter DML triggers
	+ Inserted and deleted tables
	+ Nested triggers
	+ Types of triggers
	+ Update functions
	+ Handle multiple rows in a session
	+ Performance implications of triggers

2.0 Work with data (25–30%)
------------------------------------------------------------
* 2.1 Query data by using SELECT statements
	+ Use the ranking function to select top(X) rows for multiple categories in a single query (Done)
	+ Write and perform queries efficiently using the new (SQL 2005/8->) code items such as synonyms, and joins (except, intersect) 
	+ Implement logic which uses dynamic SQL and system metadata
	+ Write efficient, technically complex SQL queries, including all types of joins versus the use of derived tables (Done)
	+ Determine what code may or may not execute based on the tables provided
	+ Given a table with constraints, determine which statement set would load a table 
	+ Use and understand different data access technologies; 
	+ Case versus isnull versus coalesce
* 2.2 Implement sub-queries (Done)
	+ Identify problematic elements in query plans; 
	+ Pivot and unpivot
	+ Apply operator
	+ Cte statement 
	+ With statement
* 2.3 Implement data types
	+ Use appropriate data
	+ Understand the uses and limitations of each data type;
	+ Impact of GUID (newid, newsequentialid) on database performance, when to use what data type for columns.
* 2.4 Implement aggregate queries (Done)
	+ New analytic functions
	+ Grouping sets
	+ Spatial aggregates
	+ Apply ranking functions
* 2.5 Query and manage XML data
	+ Understand XML datatypes and their schemas and interop w/ limitations and restrictions
	+ Implement XML schemas and handling of XML data
	+ XML data: how to handle it in SQL Server and when and when not to use it, including XML namespaces; 
	+ Import and export XML; XML indexing

3.0 Modify data (20–25%)
------------------------------------------------------------
* 3.1 Create and alter stored procedures (simple statements)
	+ Write a stored procedure to meet a given set of requirements
	+ Branching logic
	+ Create stored procedures and other programmatic objects
	+ Techniques for developing stored procedures
	+ Different types of storeproc result
	+ Create stored procedure for data access layer
	+ Program stored procedures, triggers, functions with T-SQL
* 3.2 Modify data by using INSERT, UPDATE, and DELETE statements
	+ Given a set of code with defaults, constraints, and triggers, determine the output of a set of DDL
	+ Know which SQL statements are best to solve common requirements
	+ Use output statement
* 3.3 Combine datasets
	+ Difference between UNION and UNION all
	+ case versus isnull versus coalesce
	+ modify data by using MERGE statements
* 3.4 Work with functions
	+ Understand deterministic, non-deterministic functions;
	+ Understand scalar and table values
	+ Apply built-in scalar functions; 
	+ Create and alter user-defined functions (UDFs)

4.0 Troubleshoot and optimize (25–30%)
------------------------------------------------------------
* 4.1 Optimize queries
	+ Understand statistics; 
	+ Read query plans
	+ Plan guides
	+ DMVs
	+ hints
	+ statistics IO
	+ Dynamic vs. parameterized queries
	+ Describe the different join types (HASH, MERGE, LOOP) and describe the scenarios they would be used in
* 4.2 Manage transactions
	+ Mark a transaction
	+ Understand begin tran, commit, and rollback
	+ Implicit vs explicit transactions
	+ Isolation levels
	+ Scope and type of locks
	+ Trancount
* 4.3 Evaluate the use of row-based operations vs. set-based operations
	+ When to use cursors
	+ Impact of scalar UDFs
	+ Combine multiple DML operations
* 4.4 Implement error handling
	+ Implement try/catch/throw; 
	+ Use set based rather than row based logic
	+ Transaction management