###Querying Microsoft SQL Server 2012 - Exam 70-461
{FileName}microsoft-sql70461-1-1-create_and_alter_tables-MMDDYY
{EpisodeName}Create and Alter tables
{ShowName}Querying Microsoft SQL Server 2014
{Description}
*In December 2015, this exam was evaluated for applicability to both SQL Server 2012 and SQL Server 2014. It was determined that no updates to exam objectives were required.*
####1.1 Create and alter tables using T-SQL syntax (simple statements)
*  CREATE TABLE
	+ Define Table Components Explicitly
	+ Specify data types for columns
	+ You must specify:
		- The table name
		- The table columns
			+ Column names
			+ Column data types
	+ Example
``` 
CREATE TABLE HumanResources.NewEmployee1
    (
     BusinessEntityID int NOT NULL
	,LastName nvarchar(50) NOT NULL
	,FirstName nvarchar(50) NOT NULL
	,PhoneNumber Phone NULL
	,AddressLine1 nvarchar(60) NOT NULL
	,City nvarchar(30) NOT NULL
	,State nchar(3) NOT NULL
	,PostalCode nvarchar(15) NOT NULL
	,CurrentFlag Flag
    );
GO
```

* SELECT INTO
	+ creates a table using a query output to define the new table.
		- Use SELECT INTO
``` 
SELECT c.FirstName
      ,c.LastName
	  ,e.JobTitle
	  ,a.AddressLine1
	  ,a.City
	  ,sp.Name AS [State/Province]
	  ,a.PostalCode
INTO dbo.EmployeeAddresses
FROM Person.Person AS c
    JOIN HumanResources.Employee AS e 
    ON e.BusinessEntityID = c.BusinessEntityID
    JOIN Person.BusinessEntityAddress AS bea
    ON e.BusinessEntityID = bea.BusinessEntityID
    JOIN Person.Address AS a
    ON bea.AddressID = a.AddressID
    JOIN Person.StateProvince as sp 
    ON sp.StateProvinceID = a.StateProvinceID;
GO
--Test newly created table.
SELECT *
FROM dbo.EmployeeAddresses;
```
	+ Use the ALTER TABLE statement to change some properties of columns.
		- Example
``` 
--Use HumanResources.NewEmployee--
CREATE TABLE dbo.NewEmployee2
    (
     BusinessEntityID int NOT NULL IDENTITY
	,LastName nvarchar(50) NOT NULL
	,FirstName nvarchar(50) NOT NULL
	,PhoneNumber phone NULL
	,AddressLine1 nvarchar(60) NOT NULL
	,City nvarchar(30) NOT NULL
	,State nchar(3) NOT NULL
	,PostalCode nvarchar(15) NOT NULL
    );
GO
```
``` 
--Add 2 columns into dbo.NewEmployee2--
ALTER TABLE dbo.NewEmployee2
            ADD MiddleInitial NVARCHAR(3) NULL;
GO
ALTER TABLE dbo.NewEmployee2
            ADD Email NVARCHAR(100) NULL;
GO
--Run Query to see the result--
SELECT *
FROM dbo.NewEmployees2
``` 
```
--use Alter Column to modify data types--
ALTER TABLE dbo.NewEmployees2
ALTER COLUMN email CHAR (50) ;
GO
```
* Use Table compression.
	+ Purpose: More efficient storage
	+ On Enterprise Editions, 2 Levels of Compression
		- Row-Level compression: compact storage format for each row of a table.
		- Page-level compression: row-level and page level compression
	+ Example (Will not work on Standard Edition)
```
CREATE TABLE dbo.NewEmployee3
    (
     BusinessEntityID int NOT NULL IDENTITY
	,LastName nvarchar(50) NOT NULL
	,FirstName nvarchar(50) NOT NULL
	,PhoneNumber phone NULL
	,AddressLine1 nvarchar(60) NOT NULL
	,City nvarchar(30) NOT NULL
	,State nchar(3) NOT NULL
	,PostalCode nvarchar(15) NOT NULL
	,Email nvarchar(50) NULL
    )
GO
WITH (DATA_COMPRESSION = ROW);
--change to page-level compression--
ALTER TABLE dbo.NewEmployee3
REBUILD WITH (DATA_COMPRESSION = Page);
--Run Stored Procedure to Estimate Compression Savings--
EXEC sp_estimate_data_compression_savings 'dbo', 'NewEmployee3', NULL, NULL, 'ROW' ;
GO
```