###Querying Microsoft SQL Server 2014 - Exam 70-461
============================================================
{FileName}microsoft-sql70461-1-4-create_and_alter_dml_triggers-MMDDYY
{EpisodeName}Create & alter DML Triggers
{ShowName}Querying Microsoft SQL Server 2014
{Description}
*In December 2015, this exam was evaluated for applicability to both SQL Server 2012 and SQL Server 2014. It was determined that no updates to exam objectives were required.*

#### 1.4 Create and alter DML triggers
------------------------------------------------------------

* Create and alter T-SQL AFTER and INSTEAD OF triggers.
	+ What are they used for in SQL Server?
		- DML events
		- DDL events (Create Table)
	+ How to Create a trigger?  Demonstrate in Query Window
    + Trigger is fired only ONCE per DML Statement.
	+ Trigger must be the same schema of table or view as the
	  associated table or view.
	+ Normally used for auditing and enforcing integrity rules.
	+ Fires as part of transactions with INSERT, UPDATE, or DELETE statements.
	+ To roll back changes caused by triggers and rolling back the DML statement, we can issue ROLLBACK TRAN.
	+ ROLLBACK TRAN can cause unwanted side effects.
	+ a replacement to ROLLBACK TRAN would be THROW and RAISE ERROR in your handling routines.
	+ To exit trigger use RETURN
	+ AFTER
		- fires AFTER the event is completed
		- only defined on permanent table
		- Can only be fired if the DML statements has passed all constraints.  It will faile if a constraint is violated.
		- Example
```
IF OBJECT_ID('Production.tr_ProductCategory_CategoryName', 'TR') IS NOT NULL
   DROP TRIGGER Production.tr_ProductCategory_CategoryName;
GO
CREATE TRIGGER Production.tr_ProductCategory_CategoryName
    ON Production.ProductCategory
    AFTER INSERT
	     ,UPDATE
    AS
    BEGIN
		  IF @@ROWCOUNT = 0 RETURN;
		  SET NOCOUNT ON;
		  IF EXISTS
		           (SELECT COUNT(*)
				    FROM inserted AS i
					JOIN Production.ProductCategory AS c
					     ON i.Name=c.Name
					GROUP BY i.Name
					HAVING COUNT(*) >1
				   )
	          BEGIN
			       THROW 50000, 'Duplicate category names not allowed', 0;
			  END;
    END;
	GO
``` 
```
--Test using INSERT to fire Trigger (Run Twice)--
INSERT INTO Production.ProductCategory (Name)
     VALUES ('TestCategory1');
``` 
``` 
--Test using UPDATE to fire Trigger--
UPDATE Production.ProductCategory
       SET Name ='Clothing'
	   WHERE Name = 'TestCategory1';
```
```
SELECT *
FROM Production.ProductCategory
``` 
	+ INSTEAD OF
		- fires INSTEAD of the event (INSERT, UPDATE or DELETE)
		- defined on tables and views.
		- used commonly with views
			+ if used with UPDATE, only one base table is updated
per time
			+ Views also have aggregations that can prevent a direct update

* Describe the inserted and deleted tables used by triggers.
	+ Tables that contain rows affected by any modification that causes the trigger to fire.
	+ inserted: image of affected rows when using INSERT and UPDATE with AFTER
	+ deleted: image of affected rows when using DELETE and UPDATE statements with AFTER
	+ deleted and inserted tables when using DML statement if using INSTEAD OF
* Describe how nested triggers work.
	+ e.g. Trigger on one table can cause update to another table.
	+ 32 nested trigger fires
	+ Can be disabled: `EXEC sp_configure 'nested triggers'`;
		- at Server Level `EXEC sp_configure 'nested triggers'`,0; RECONFIGURE
* Use the UPDATE function in a trigger.
	+ Create a trigger to print a message when anyone tried to update two fields
* Handle multiple rows in a trigger.
	+ Columns_Updated()
* Describe the impact triggers can have on performance.
