###Querying Microsoft SQL Server 2012 - Exam 70-461
{FileName}microsoft-sql70461-2-1-basic_select_queries-MMDDYY
{EpisodeName} Basic SELECT Queries
{ShowName}Querying Microsoft SQL Server 2012
{Description}
*In December 2015, this exam was evaluated for applicability to both SQL Server 2012 and SQL Server 2014. It was determined that no updates to exam objectives were required.*
####2.0 Work with data (25–30%)
* 2.1 Query data by using SELECT statements
	+ Basic SELECT statement
```
SELECT HumanResources.Employee.BusinessEntityID
       ,HumanResources.Employee.LoginID
	   ,HumanResources.Employee.JobTitle
	   ,HumanResources.Employee.HireDate
FROM HumanResources.Employee
;
GO
```
	+ Using aliases in FROM for efficiency
```
SELECT e.BusinessEntityID
       ,e.LoginID
	   ,e.JobTitle
	   ,e.HireDate
FROM HumanResources.Employee as e;
GO
```
	+ Using WHERE to filter
```
SELECT e.BusinessEntityID
       ,e.LoginID
	   ,e.JobTitle
	   ,e.HireDate
FROM HumanResources.Employee as e
WHERE e.HireDate >= '2003-01-01';
GO
```
	+ Using GROUP BY to group data together
```
SELECT --e.BusinessEntityID
       --,e.LoginID
	   e.JobTitle
	   --,e.HireDate
	   ,count (e.Hiredate)
FROM HumanResources.Employee as e
WHERE e.HireDate >= '2003-01-01'
GROUP BY JobTitle;
GO
```
	+ Using HAVING to filter grouped data
```
SELECT --e.BusinessEntityID
       --,e.LoginID
	   e.JobTitle
	   --,e.HireDate
	   ,count (e.Hiredate) as "Number of"
FROM HumanResources.Employee as e
WHERE e.HireDate >= '2003-01-01'
GROUP BY JobTitle
HAVING count(e.Hiredate) >=3;
GO
```
	+ Returning non-duplicates 
```
SELECT DISTINCT HumanResources.Employee.JobTitle
	   ,HumanResources.Employee.HireDate
FROM HumanResources.Employee
ORDER BY HireDate DESC;
GO
```
	+ Simple CASE Expression
	```
 Use AdventureWorks2014;
GO
--Query for the Products and Categories
SELECT prod.ProductId
      ,prod.name as ProductName
	  ,prod.ProductsubcategoryID as Category
FROM Production.Product as prod;
GO
--Take the Category value and report a meaningful value for it.
SELECT prod.ProductId,prod.name as ProductName
	  ,prod.ProductsubcategoryID as Category
	  ,CASE prod.ProductsubcategoryID
          WHEN 1 THEN 'Mountain'
	      WHEN 2 THEN 'Road Racing'
	      WHEN 3 THEN 'Touring'
	      ELSE 'Parts'
       END AS Categoryname
FROM Production.Product as prod;
GO
```