###Querying Microsoft SQL Server 2014 - Exam 70-461
{FileName}microsoft-sql70461-2-2-query_using_joins-MMDDYY
{EpisodeName}Query using JOINS
{ShowName}Querying Microsoft SQL Server 2014
{Description}
*In December 2015, this exam was evaluated for applicability to both SQL Server 2012 and SQL Server 2014. It was determined that no updates to exam objectives were required.*
####2.2 Query using JOINS
* Write efficient, technically complex SQL queries, including *all types of joins* versus the use of *derived tables* 
	+ Queries using JOINS
		- Theory on Using Joins (Simple Diagram)
			+ When we need to query for result from more than a single table.
			+ With 2 tables, must determine a column of data which can link them together
		- Query using INNER JOIN
			+ result: dataset that has a matching value between the two tables.
			+ Example:
```
/* Query 2 tables for results we want, Assumption Example. */
SELECT sp.BusinessEntityID
      ,p.FirstName
	  ,p.LastName
	  ,sp.SalesLastYear
FROM Sales.SalesPerson AS sp, Person.Person AS p;
GO
``` 
```
--Linking the 2 tables together to get the result we want.
SELECT sp.BusinessEntityID
      ,p.FirstName
	  ,p.LastName
	  ,sp.SalesLastYear
FROM Sales.SalesPerson AS sp
     INNER JOIN Person.Person AS p
	 ON sp.BusinessEntityID=p.BusinessEntityID;
GO
```
		- Query using LEFT JOIN
			+ result: data set that has matching values between two tables and all values from left table.
			+ Example:
```
--Linking the 2 tables together to get the result we want.
SELECT sp.BusinessEntityID
      ,p.FirstName
	  ,p.LastName
	  ,sp.SalesLastYear
FROM Sales.SalesPerson AS sp
     LEFT JOIN Person.Person AS p
	 ON sp.BusinessEntityID=p.BusinessEntityID;
GO
```
		- Query using RIGHT JOIN
			+ result: data set that has matching values between two tables and all values from right table.
			+ Example:
```
--Linking the 2 tables together to get the result we want.
SELECT sp.BusinessEntityID
      ,p.FirstName
	  ,p.LastName
	  ,sp.SalesLastYear
FROM Sales.SalesPerson AS sp
     RIGHT JOIN Person.Person AS p
	 ON sp.BusinessEntityID=p.BusinessEntityID;
GO
```
		- Queries using derived tables
			+ Designed to help with data queries on the fly.
			+ Temporary tables or views used to define how data should look before final output.
				- Problematic:  you must create the temp table, then populate the temp table, then query the temp table.  Of course you mus then cleanup the temporary table.
				- Views Problematic: you must predefine how data is to look, create the view and use view in the query.
			+ Derived tables are created on the fly, unlike temporary tables, derived tables are created and populated in a single step and only used as an input.
			+ 1st TotalSales by Each CustomerID 
``` 
/* Query to find out how I can categorize each of my customers
into categories based on TotalSales */
--TotalSales by each CustomerID
SELECT   soh.CustomerID, 
         SUM (sod.UnitPrice * sod.OrderQty) AS TotalSales 
FROM     Sales.SalesOrderDetail AS sod 
         INNER JOIN Sales.SalesOrderHeader AS soh 
           ON sod.SalesOrderID = soh.SalesOrderID 
GROUP BY soh.CustomerID
ORDER BY TotalSales DESC;
--returns 19119 rows
``` 
			+ 2nd Query that returns all Customers to each group
```language
```
SELECT   soh.CustomerID
		,SUM (sod.UnitPrice * sod.OrderQty) AS TotalSales
		,CASE
		     WHEN SUM (sod.UnitPrice * sod.OrderQty)
			      BETWEEN 0 AND 5000 THEN 'Micro'
			 WHEN SUM (sod.UnitPrice * sod.OrderQty)
			      BETWEEN 5001 AND 10000 THEN 'Mini'
			 WHEN SUM (sod.UnitPrice * sod.OrderQty)
			      BETWEEN 10001 AND 15000 THEN 'Medium'
             WHEN SUM (sod.UnitPrice * sod.OrderQty)
			      BETWEEN 15001 AND 20000 THEN 'Mega'
			 WHEN SUM (sod.UnitPrice * sod.OrderQty)
			      > 20000 THEN 'Mighty'
		  END AS OrderGroup
FROM Sales.SalesOrderDetail AS sod 
     INNER JOIN Sales.SalesOrderHeader AS soh 
     ON sod.SalesOrderID = soh.SalesOrderID 
GROUP BY soh.CustomerID
ORDER BY TotalSales DESC;
GO
```
			+ 3rd Use a Derived Table, to find out HOW MANY customers are in each OrderGroup
```
SELECT	og.OrderGroup
		,COUNT(og.OrderGroup) as NumberOf
FROM	(SELECT soh.CustomerID
		       ,SUM (sod.UnitPrice * sod.OrderQty) AS TotalSales
		       ,CASE
		            WHEN SUM (sod.UnitPrice * sod.OrderQty)
			        BETWEEN 0 AND 5000 THEN 'Micro'
			        WHEN SUM (sod.UnitPrice * sod.OrderQty)
			        BETWEEN 5001 AND 10000 THEN 'Mini'
			        WHEN SUM (sod.UnitPrice * sod.OrderQty)
			        BETWEEN 10001 AND 15000 THEN 'Medium'
                    WHEN SUM (sod.UnitPrice * sod.OrderQty)
			        BETWEEN 15001 AND 20000 THEN 'Mega'
			        WHEN SUM (sod.UnitPrice * sod.OrderQty)
			        > 20000 THEN 'Mighty'
				END AS OrderGroup
			FROM Sales.SalesOrderDetail AS sod 
			INNER JOIN Sales.SalesOrderHeader AS soh 
			ON sod.SalesOrderID = soh.SalesOrderID 
			GROUP BY soh.CustomerID) AS og
GROUP BY og.OrderGroup;
GO
```