###Querying Microsoft SQL Server 2014 - Exam 70-461
{FileName}microsoft-sql70461-2-2-query_using_joins-MMDDYY
{EpisodeName}Query using JOINS
{ShowName}Querying Microsoft SQL Server 2014
{Description}
*In December 2015, this exam was evaluated for applicability to both SQL Server 2012 and SQL Server 2014. It was determined that no updates to exam objectives were required.*
####2.2 Query using JOINS
* Write efficient, technically complex SQL queries, including *all types of joins* versus the use of *derived tables* 
	+ Queries using JOINS
	    - Derived tables are created on the fly, unlike temporary tables, derived tables are created and populated in a single step and only used as an input.
			+ 1st TotalSales by Each CustomerID 
``` 
/* Query to find out how I can categorize each of my customers
into categories based on TotalSales */
--TotalSales by each CustomerID
SELECT   soh.CustomerID, 
         SUM (sod.UnitPrice * sod.OrderQty) AS TotalSales 
FROM     Sales.SalesOrderDetail AS sod 
         INNER JOIN Sales.SalesOrderHeader AS soh 
           ON sod.SalesOrderID = soh.SalesOrderID 
GROUP BY soh.CustomerID
ORDER BY TotalSales DESC;
--returns 19119 rows
``` 
			+ 2nd Query that returns all Customers to each group
```language
```
SELECT   soh.CustomerID
		,SUM (sod.UnitPrice * sod.OrderQty) AS TotalSales
		,CASE
		     WHEN SUM (sod.UnitPrice * sod.OrderQty)
			      BETWEEN 0 AND 5000 THEN 'Micro'
			 WHEN SUM (sod.UnitPrice * sod.OrderQty)
			      BETWEEN 5001 AND 10000 THEN 'Mini'
			 WHEN SUM (sod.UnitPrice * sod.OrderQty)
			      BETWEEN 10001 AND 15000 THEN 'Medium'
             WHEN SUM (sod.UnitPrice * sod.OrderQty)
			      BETWEEN 15001 AND 20000 THEN 'Mega'
			 WHEN SUM (sod.UnitPrice * sod.OrderQty)
			      > 20000 THEN 'Mighty'
		  END AS OrderGroup
FROM Sales.SalesOrderDetail AS sod 
     INNER JOIN Sales.SalesOrderHeader AS soh 
     ON sod.SalesOrderID = soh.SalesOrderID 
GROUP BY soh.CustomerID
ORDER BY TotalSales DESC;
GO
```
			+ 3rd Use a Derived Table, to find out HOW MANY customers are in each OrderGroup
```
SELECT	og.OrderGroup
		,COUNT(og.OrderGroup) as NumberOf
FROM	(SELECT soh.CustomerID
		       ,SUM (sod.UnitPrice * sod.OrderQty) AS TotalSales
		       ,CASE
		            WHEN SUM (sod.UnitPrice * sod.OrderQty)
			        BETWEEN 0 AND 5000 THEN 'Micro'
			        WHEN SUM (sod.UnitPrice * sod.OrderQty)
			        BETWEEN 5001 AND 10000 THEN 'Mini'
			        WHEN SUM (sod.UnitPrice * sod.OrderQty)
			        BETWEEN 10001 AND 15000 THEN 'Medium'
                    WHEN SUM (sod.UnitPrice * sod.OrderQty)
			        BETWEEN 15001 AND 20000 THEN 'Mega'
			        WHEN SUM (sod.UnitPrice * sod.OrderQty)
			        > 20000 THEN 'Mighty'
				END AS OrderGroup
			FROM Sales.SalesOrderDetail AS sod 
			INNER JOIN Sales.SalesOrderHeader AS soh 
			ON sod.SalesOrderID = soh.SalesOrderID 
			GROUP BY soh.CustomerID) AS og
GROUP BY og.OrderGroup;
GO
```