###Querying Microsoft SQL Server 2012 - Exam 70-461
{FileName}microsoft-sql70461-2-3-implement_subqueries-MMDDYY
{EpisodeName}Implement Subqueries
{ShowName}Querying Microsoft SQL Server 2012
{Description}
*In December 2015, this exam was evaluated for applicability to both SQL Server 2012 and SQL Server 2014. It was determined that no updates to exam objectives were required.*
####2.3 Implement Subqueries
* Identify problematic elements in query plans
	+ Result of subquery is not a "single value" or scalar when that is what is expected.  Look for "=" in WHERE clause
	+ **Scalar subqueries** are written to return a value to the outer query and can run independent of the outer query.
		- Assumption
``` 
SELECT p.FirstName+' '+p.LastName as SalesPerson
FROM Person.Person as p
     INNER JOIN Sales.Salesperson as sp
     ON p.BusinessEntityID=sp.BusinessEntityID
WHERE Bonus = (SELECT sp.Bonus as Bonus
               FROM sales.salesperson as sp
			   );
```
		- Scalar Subquery: returns a single value to outer query
```
SELECT p.FirstName+' '+p.LastName as SalesPerson
      ,Bonus
FROM Person.Person as p
     INNER JOIN Sales.Salesperson as sp
     ON p.BusinessEntityID=sp.BusinessEntityID
WHERE Bonus = (SELECT MAX(sp.Bonus) as Bonus
               FROM sales.salesperson as sp
			   );
```
	+ Result of subquery is** multi-valued**.  Look for "in" in WHERE clause.  SELECT clause can be rewritten as JOIN.
		- Multi-values returned to outer query
```
SELECT p.FirstName+' '+p.LastName as SalesPerson
      ,Bonus
FROM Person.Person as p
     INNER JOIN Sales.Salesperson as sp
     ON p.BusinessEntityID=sp.BusinessEntityID
WHERE Bonus IN (SELECT sp.Bonus as Bonus
                FROM sales.salesperson as sp
			    );
```
	+ **Correlated subqueries** is where the outer query returns value to the inner query.  It is dependent and cannot be run separately from outer query.  These can be created in the WHERE and HAVING clauses too!
		- Correlated Subquery in SELECT Clause
``` 
SELECT c.CustomerID
      ,st.Name
	  ,(SELECT SUM(sod.unitprice * sod.OrderQty)
        FROM sales.SalesOrderDetail as sod
        INNER JOIN sales.SalesOrderHeader as soh 
		ON sod.SalesOrderID = soh.SalesOrderID
        WHERE soh.CustomerID = c.CustomerID) AS TotalSales
FROM Sales.Customer AS c
     INNER JOIN Sales.SalesTerritory as st
	 ON c.TerritoryID=st.TerritoryID
ORDER BY TotalSales DESC
```
