###Querying Microsoft SQL Server 2012 - Exam 70-461
{FileName}microsoft-sql70461-2-5-query_using_synonyms_except_intersect-MMDDYY
{EpisodeName}Query Using Synonyms, Except and Intersect
{ShowName}Querying Microsoft SQL Server 2012
{Description}
*In December 2015, this exam was evaluated for applicability to both SQL Server 2012 and SQL Server 2014. It was determined that no updates to exam objectives were required.*
####2.4 Query Using Synonyms, Except and Intersect
* Write and perform queries efficiently using the new (SQL 2005/8->) code items such as synonyms, and joins (except, intersect)
	- Synonyms
		+ Provide an Alias to a new object or an existing database object.
		+ It is a pointer and not considered an object
		+ To create a synonym, you must have CREATE SYNONYM permissions.
			- Sysadmins or db_owner have this privilege and can grant that permission to others.
			- If you're creating a synonym for an object in another database you need to have permissions there too.
		+ Synonyms can be created for:
			- Created for objects that do not yet exist.
			- Tables
			- Views
			- Stored Procedures
			- Functions
			- Aggregations
		+ A synonym cannot reference another synonym
		+ A synonym cannot be used in DDL statements
		+ A synonym cannot be altered or changed do so you must use DROP SYNONYM to drop it and then you can recreate it.
		+ Example 1: Synonym for a Table Name
``` 
CREATE SYNONYM dbo.DEPT_HISTORY 
FOR HumanResources.EmployeeDepartmentHistory;
--Test the use of the synonym--
SELECT * 
FROM dbo.DEPT_HISTORY
```
		+ Example 2: Synonym for a Created VIEW
``` 
--Create a VIEW--
CREATE VIEW TotalCustomerQtyByMonth (CustomerID,OrderDate,OrderQty)
WITH SCHEMABINDING
AS
SELECT soh.CustomerID
      ,MONTH(soh.OrderDate) Month
	  ,SUM (sod.OrderQty) Quantity
FROM Sales.SalesOrderHeader AS soh
     INNER JOIN Sales.SalesOrderDetail AS sod
	 ON soh.SalesOrderID=sod.SalesOrderID
GROUP BY soh.CustomerID,soh.OrderDate;
GO
--Create a Synonym for the dbo.TotalCustomerQtyByMonth--
CREATE SYNONYM dbo.CustQty FOR dbo.TotalCustomerQtyByMonth;
GO
--Test the use of the Synonym--
SELECT CustomerID
      ,OrderDate
	  ,OrderQty
FROM dbo.CustQty;
GO
```
		+ INTERSECT
			- Very Similar to an INNER JOIN between two select statement.
			- Returns only distinct rows that are common to both sets.
			- INTERSECT Example
```
SELECT cr. Name AS Country
      ,pro. Name AS Region
	  ,a. city
FROM Person.CountryRegion as cr
     INNER JOIN Sales.SalesTerritory as st
	 ON cr.CountryRegionCode=st.CountryRegionCode
	 INNER JOIN Sales.SalesPerson as sp
	 ON st.TerritoryID=sp.TerritoryID
	 INNER JOIN Person.StateProvince as pro
	 ON st.TerritoryID=pro.TerritoryID
	 INNER JOIN Person.Address as a
	 ON pro.StateProvinceID=a.StateProvinceID
INTERSECT 
SELECT cr.Name AS Country
      ,pro.Name AS Region
	  ,a.city AS City
FROM Sales.Customer AS c
     INNER JOIN Sales.SalesTerritory as st
	 ON c.TerritoryID=st.TerritoryID
	 INNER JOIN Person.CountryRegion as cr
	 ON st.CountryRegionCode=cr.CountryRegionCode
	 INNER JOIN Person.StateProvince as pro
	 ON cr.CountryRegionCode=pro.CountryRegionCode
	 INNER JOIN Person.Address as a
	 ON pro.StateProvinceID=a.StateProvinceID;
```
		+ EXCEPT
			- Returns distinct rows that appear in the first query but not the second.
			- Except Example
```
SELECT soh.SalesPersonID, soh.CustomerID
FROM Sales.SalesOrderHeader as soh
WHERE soh.CustomerID=29734
EXCEPT
SELECT soh.SalesPersonID, soh.CustomerID
FROM Sales.SalesOrderHeader as soh
WHERE soh.CustomerID=29994;
```