###Querying Microsoft SQL Server 2012 - Exam 70-461
{FileName}microsoft-sql70461-2-7-work_with_conditions_and_nulls-MMDDYY
{EpisodeName}Work with Conditions and Nulls
{ShowName}Querying Microsoft SQL Server 2012
{Description}
*In December 2015, this exam was evaluated for applicability to both SQL Server 2012 and SQL Server 2014. It was determined that no updates to exam objectives were required.*
####2.7 Work with Conditions and Nulls
* **Case** versus **isnull** versus **coalesce**
	+  **CASE** 
		- What Does CASE do?
			+ Sets multiple conditions to match; provides a different answer based on the condition.
			+ When do I use it?
				- e.g. Flag when to reorder on based on stock levels.
			+ Example of using CASE:
				- Recatagorize items based on result from another column value.
``` 
SELECT prod.ProductId,prod.name as ProductName, prod.ProductsubcategoryID as Category,
CASE prod.ProductsubcategoryID
     WHEN 1 THEN 'Mountain'
	 WHEN 2 THEN 'Road'
	 WHEN 3 THEN 'Touring'
	 ELSE 'Parts'
END AS Categoryname
FROM Production.Product as prod;
GO
```
	+ **ISNULL**
		- What Does IS NULL do?
			+ Tests for NULL
			+ replaces NULL value with another value
			+ not an ANSI standard
		- When do I use it?
			+ when replacing a NULL with a value of your choosing of the same datatype.
		- Example of using ISNULL
			+ Using Same example as CASE
``` 
SELECT prod.ProductId,prod.name as ProductName, prod.ProductsubcategoryID as Category,
CASE prod.ProductsubcategoryID
     WHEN 1 THEN 'Mountain'
	 WHEN 2 THEN 'Road'
	 WHEN 3 THEN 'Touring'
	 ELSE 'Parts'
END AS Categoryname
FROM Production.Product as prod
WHERE prod.ProductSubcategoryID IS NOT NULL;
```
	+ **Coalesce** 
		- What Does COALESCE do?
			+ can replace NULL with another value.
			+ If all arguments are null, COALESCE will return NULL.
		- When do I use it? 
				- reduce number of rows to be queried if values are NULL.
		- Example of using COALESCE:
```
SELECT Name, Class, Color, ProductNumber,
COALESCE(Class, Color, ProductNumber) AS FirstNotNull
FROM Production.Product;
```