###Querying Microsoft SQL Server 2012 - Exam 70-461
{FileName}microsoft-sql70461-2-9-query_and_manage_xml-MMDDYY
{EpisodeName}Query and Manage XML Data
{ShowName}Querying Microsoft SQL Server 2012
{Description}
*In December 2015, this exam was evaluated for applicability to both SQL Server 2012 and SQL Server 2014. It was determined that no updates to exam objectives were required.*
####2.9 Query and Manage XML Data
* Understand XML datatypes and their schemas and interop w/ limitations and restrictions
	- Why Use XML in our database?
		+ flexible and scalable in our existing databases.
```
SELECT *
FROM Person.Person
```
* XML data: how to handle it in SQL Server and when and when not to use it, including XML namespaces
	+ Create XML Data from Relational Data
		- FOR XML RAW
```
--Returns all values as a row--
USE AdventureWorks2014;
GO
SELECT p.BusinessEntityID
      ,p.PersonType
	  ,p.Title
	  ,p.FirstName
	  ,p.MiddleName
	  ,p.LastName
	  ,p.Suffix
FROM Person.Person as p
WHERE p.BusinessEntityID = 10001
FOR XML RAW
GO
		- FOR XML AUTO
```
-- VALUES DISPLAYED AS ATTRIBUTE--
USE AdventureWorks2014;
GO
SELECT p.BusinessEntityID
      ,p.PersonType
	  ,p.Title
	  ,p.FirstName
	  ,p.MiddleName
	  ,p.LastName
	  ,p.Suffix
FROM Person.Person as p
WHERE p.BusinessEntityID = 10001
FOR XML AUTO
GO
```
``` 
-- VALUES DISPLAYED AS A NODE ELEMENT--
SELECT p.BusinessEntityID
      ,p.PersonType
	  ,p.Title
	  ,p.FirstName
	  ,p.MiddleName
	  ,p.LastName
	  ,p.Suffix
FROM Person.Person as p
WHERE p.BusinessEntityID = 10001
FOR XML AUTO, ELEMENTS
GO
```
		- FOR XML PATH
``` 
--CHANGE SCHEMA AND TABLE NAME--
SELECT p.BusinessEntityID
      ,p.PersonType
	  ,p.Title
	  ,p.FirstName
	  ,p.MiddleName
	  ,p.LastName
	  ,p.Suffix
FROM Person.Person as p
WHERE p.BusinessEntityID = 10001
FOR XML PATH('Person')
GO
```
```
-- COMBINE ATTRIBUTE AND NODE ELEMENT--
SELECT p.BusinessEntityID AS '@BID'
      ,p.PersonType
	  ,p.Title
	  ,p.FirstName
	  ,p.MiddleName
	  ,p.LastName
	  ,p.Suffix
FROM Person.Person as p
WHERE p.BusinessEntityID = 10001
FOR XML PATH('Person')
GO
```
	+ Shredding XML to Tables
		- Taking XML documents and fields and importing values into tables.
``` 
* Implement XML schemas and handling of XML data
``` 
--XQuery Value, Note the query--
SELECT p.FirstName
      ,p.LastName
	  ,Demographics.value('declare namespace ns="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey"; (/ns:IndividualSurvey/ns:Occupation)[1]','varchar(50)') AS Occupation
	  ,Demographics.value('declare namespace ns="http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey"; (/ns:IndividualSurvey/ns:Education)[1]','varchar(50)') AS Education
FROM Person.Person as p
WHERE BusinessEntityID = 1999;
GO
```
``` 
--XML Namespaces, Note the query--
;WITH XMLNAMESPACES ('http://schemas.microsoft.com/sqlserver/2004/07/adventure-works/IndividualSurvey' AS ns)
SELECT p.FirstName
      ,MiddleName
	  ,LastName
	  ,Demographics.value('(/ns:IndividualSurvey/ns:Occupation)[1]','varchar(50)') AS Occupation
	  ,Demographics.value('(/ns:IndividualSurvey/ns:Education)[1]','varchar(50)') AS Education
FROM Person.Person as p
WHERE BusinessEntityID = 1999;
GO
```
* XML indexing
	+ Primary
		- One row of information for each node in the XML column.
		- a Shredded representation of XML values.
		- Can only be created on tables with a clustered primary key.
	+ Secondary
		- Must create a primary XML index first before secondary index
		- use for optimizing certain types of XML queries.
			+ PATH used to optimize queries that use XML PATH
			+ PROPERTY used to optimize queries where primary key field is used.
			+ VALUE used to optimize queries where wildcards in path are used to find values.