###Querying Microsoft SQL Server 2012 - Exam 70-461
{FileName}microsoft-sql70461-3-2-use_insert_update_and_delete-MMDDYY
{EpisodeName}Use INSERT, UPDATE and DELETE Statements
{ShowName}Querying Microsoft SQL Server 2012
{Description}
####3.0 Modify data (20–25%)
* 3.2 Modify data by using INSERT, UPDATE, and DELETE statements
/* Create a table using SELECT INTO */
SELECT c.FirstName
      ,c.LastName
	  ,e.JobTitle
	  ,a.AddressLine1
	  ,a.City
	  ,sp.Name AS [State/Province]
	  ,a.PostalCode
INTO dbo.NewEmployee1
FROM Person.Person AS c
    JOIN HumanResources.Employee AS e 
    ON e.BusinessEntityID = c.BusinessEntityID
    JOIN Person.BusinessEntityAddress AS bea
    ON e.BusinessEntityID = bea.BusinessEntityID
    JOIN Person.Address AS a
    ON bea.AddressID = a.AddressID
    JOIN Person.StateProvince as sp 
    ON sp.StateProvinceID = a.StateProvinceID;
GO
--Test newly created table.
SELECT *
FROM dbo.newEmployee1;
```
	+ Know which SQL statements are best to solve common requirements (UPDATE)
		- UPDATE (statement)
``` 
SELECT sod.SalesOrderID
      ,sod.ProductID
	  ,sod.OrderQty
	  ,sod.UnitPrice
	  ,sod.UnitPriceDiscount
	  ,sod.LineTotal
FROM Sales.SalesOrderDetail as sod
WHERE sod.SalesOrderID = '43659'
--update to increase discount
UPDATE Sales.salesorderdetail
SET UnitPriceDiscount +=.05
WHERE SalesOrderID = '43659'
--update to decrease discount
UPDATE Sales.salesorderdetail
SET UnitPriceDiscount -=.05
WHERE SalesOrderID = '43659'
```
		- UPDATE (based on join)
``` 
--UPDATE sales.SalesOrderDetail
--set UnitPriceDiscount += 0.10
SELECT sod.SalesOrderID
      ,sod.ProductID
	  ,sod.OrderQty
	  ,sod.UnitPrice
	  ,sod.UnitPriceDiscount
	  ,sod.LineTotal
	  ,cr.Name
FROM Sales.SalesOrderDetail as sod
     INNER JOIN Sales.SalesOrderHeader as soh
	 ON sod.SalesOrderID=soh.SalesOrderID
	 INNER JOIN Sales.SalesTerritory as st
	 ON soh.TerritoryID=st.TerritoryID
	 INNER JOIN Person.CountryRegion as cr
	 ON st.CountryRegionCode=cr.CountryRegionCode
WHERE cr.Name = 'Germany'
```
		- UPDATE (nondeterministic)
			+ must be careful - arbitrary
			+ instead choose to use MERGE.  this will generate an error that will ask you to be more deterministic (specific)
	+ Know which SQL statements are best to solve common requirements (DELETE)
		- DELETE (statement)
``` 
SELECT SalesOrderID,ProductID,OrderQty,UnitPrice,UnitPriceDiscount
INTO dbo.DiscountedProducts
FROM Sales.SalesOrderDetail as sod
--Verify INFO
SELECT *
FROM dbo.DiscountedProducts
WHERE ProductID = 712
--DELETE
DELETE FROM dbo.DiscountedProducts
WHERE ProductID = 712
```
		- TRUNCATE 
		- DELETE (Based on a Join)
``` 
SELECT soh.OrderDate
      ,sod.SalesOrderID
	  ,sod.OrderQty
	  ,pcat.Name AS Category
      ,sod.ProductID 
      ,prod.Name
	  ,v.Name as VendorName
FROM Sales.SalesOrderHeader AS soh
     INNER JOIN 
     Sales.SalesOrderDetail AS sod
	 ON soh.SalesOrderID=sod.SalesOrderID
     INNER JOIN Production.Product AS prod
	 ON sod.ProductID=prod.ProductID
	 INNER JOIN Production.ProductSubcategory AS psub
	 ON prod.ProductSubcategoryID=psub.ProductSubcategoryID
	 INNER JOIN Production.ProductCategory AS pcat
	 ON psub.ProductCategoryID=pcat.ProductCategoryID
	 INNER JOIN Purchasing.ProductVendor AS pv
	 ON prod.ProductID=pv.ProductID
	 INNER JOIN Purchasing.Vendor AS v
	 ON pv.BusinessEntityID=v.BusinessEntityID
WHERE pcat.Name = 'Clothing'
```
