###Querying Microsoft SQL Server 2012 - Exam 70-461
{FileName}microsoft-sql70461-3-3-combine_datasets-MMDDYY
{EpisodeName}Combine Datasets
{ShowName}Querying Microsoft SQL Server 2012
{Description}
####3.0 Modify data (20–25%)
* 3.3 Combine datasets
	+ Difference between UNION and UNION all
		- Rules:
			+ Each query must have same number of columns
			+ Each column must have compatible data types
			+ Column Names are generated from first query
		- Use ORDER BY and COMPUTE for overall result set
		- Use GROUP BY and HAVING for each result set.
		- UNION joins multiple result sets into one and removes all duplicates.
		- example
``` 
SELECT *
FROM HumanResources.Employee
UNION
SELECT *
FROM HumanResources.Employee
UNION
SELECT *
FROM HumanResources.Employee
--ORDER BY JobTitle
--Look at execution plan
```
		- Performs a DISTINCT operation on the result set.
		- UNION ALL joins multiple resultsets into one but doesn't remove duplicate rolls
		- Example
``` 
SELECT *
FROM HumanResources.Employee
UNION ALL
SELECT *
FROM HumanResources.Employee
UNION ALL
SELECT *
FROM HumanResources.Employee
--ORDER BY JobTitle
--Look at execution plan
```
	+ Modify data by using MERGE statements
		- applies Server 2008 and later
		- conditionally merges data from result set to target table and works differently based on the existence of the data in the table.  (combines conditionally INSERT, UPDATE and DELETE into a single statement)
		- Example
``` 
--Synchronize the target table with refreshed data from source table
MERGE Products AS TARGET
USING UpdatedProducts AS SOURCE 
ON (TARGET.ProductID = SOURCE.ProductID) 
--When records are matched, update the records if there is any change
WHEN MATCHED AND TARGET.ProductName <> SOURCE.ProductName 
OR TARGET.Rate <> SOURCE.Rate THEN 
UPDATE SET TARGET.ProductName = SOURCE.ProductName, 
TARGET.Rate = SOURCE.Rate 
--When no records are matched, insert the incoming records from source table to target table
WHEN NOT MATCHED BY TARGET THEN 
INSERT (ProductID, ProductName, Rate) 
VALUES (SOURCE.ProductID, SOURCE.ProductName, SOURCE.Rate)
--When there is a row that exists in target table and same record does not exist in source table
--then delete this record from target table
WHEN NOT MATCHED BY SOURCE THEN 
DELETE
--$action specifies a column of type nvarchar(10) 
--in the OUTPUT clause that returns one of three 
--values for each row: 'INSERT', 'UPDATE', or 'DELETE', 
--according to the action that was performed on that row
OUTPUT $action, 
DELETED.ProductID AS TargetProductID, 
DELETED.ProductName AS TargetProductName, 
DELETED.Rate AS TargetRate, 
INSERTED.ProductID AS SourceProductID, 
INSERTED.ProductName AS SourceProductName, 
INSERTED.Rate AS SourceRate; 
SELECT @@ROWCOUNT;
GO
```