###Querying Microsoft SQL Server 2012 - Exam 70-461
{FileName}microsoft-sql70461-3-4-work_with_functions-MMDDYY
{EpisodeName}Create & Alter Stored Procedures
{ShowName}Querying Microsoft SQL Server 2012
{Description}
####3.0 Modify data (20–25%)
* 3.4 Work with functions
	+ Understand deterministic, non-deterministic functions;
	+ Understand scalar and table values
	+ Apply built-in scalar functions; 
	+ Create and alter user-defined functions (UDFs)
		- returns scalar value to table or caller
		- can accept parameters
		- executed as part of SQL command not using EXEC
		- cannot perform any DDL. Cannot create tables, modify tables, indexes or any data changes in tables
* Two types of User Defined Functions (UDFs)
	+ Scalar: returns single value back to caller
``` 
--Create a scalar function--
IF OBJECT_ID('sales.fn_total', 'FN') IS NOT NULL
    DROP FUNCTION sales_fn_extension
GO
CREATE FUNCTION sales.fn_total
(
  @unitprice AS MONEY,
  @qty AS INT
)
RETURNS MONEY
AS
  BEGIN
  RETURN @unitprice * @qty 
  END;
GO
--Use the sales.fn_total in query
SELECT sod.SalesOrderID,sod.UnitPrice,sales.fn_total(unitprice,qty)as Extension
FROM Sales.SalesOrderDetail
```
* Table-valued: return a table back to caller
	+ tvfs can appear in FROM clause
	+ Inline TVF is a single SELECT statement that returns a table. It cannot be executed by itself
	+ Example
``` 
IF OBJECT_ID('Sales.fn_FilteredRange', 'IF') IS NOT NULL
    DROP FUNCTION Sales.fn_FilteredRange;
GO
CREATE FUNCTION Sales.fn_FilteredRange
(
 @lowqty AS SMALLINT,
 @highqty AS SMALLINT
)
RETURNS TABLE AS RETURN
(
 SELECT sod.SalesOrderID
	   ,sod.UnitPrice
	   ,sod.OrderQty
 FROM Sales.SalesOrderDetail as sod
 WHERE OrderQty BETWEEN @lowqty AND @highqty
);
GO
--Test InlineTVF
SELECT SalesOrderID
      ,UnitPrice
	  ,OrderQty
FROM Sales.fn_FilteredRange (10,20);
```