###Querying Microsoft SQL Server 2012 - Exam 70-461
{FileName}microsoft-sql70461-4-1-optimize_queries-MMDDYY
{EpisodeName}Optimize Queries
{ShowName}Querying Microsoft SQL Server 2012
{Description}
####4.0 Troubleshoot and optimize (25–30%)
* 4.1 Optimize queries
	+ Understand statistics
		- Two Types: 
			+ SET STATISTICS TIME ON|OFF:displays details about time to prepare and compile query and total elapsed time of query. 
			+ SET STATISTICS IO ON|OFF:displays about disk activity generated by query.  Results displayed in 8K blocks (PAGES); 64K = EXTENT; 1MB = 128 PAGES
		- example
```
SET STATISTICS TIME ON;
GO
SELECT SalesOrderID, CustomerID, SalesPersonID, OrderDate 
FROM Sales.SalesOrderHeader;
GO
SET STATISTICS TIME OFF;
GO
```
```
SET STATISTICS IO ON;
GO
SELECT SalesOrderID, CustomerID, SalesPersonID, OrderDate 
FROM Sales.SalesOrderHeader;
GO 
SET STATISTICS IO OFF;
GO
```
	+ Read query plans
		- Displays how SQL breaks down a query
		- identifies where issues exist in execution
		- If a query take a long time to run, then use execution plans to help tune.
		- TWO type of Execution Plans:
			+ Actual Execution Plan (Ctrl+M): created AFTER the execution of the query and the steps were performed
			+ Estimated Execution Plan (Ctrl+L): created without running query and is an approximation
		- 3 presentations of execution plans
			+ Text Plans
			+ Graphical Plans
			+ XML Plans
* Plan guides
	+ can influence query optimization by attaching hints and or a query plan to them.
	+ When query executes, the optimizer matches the SQL statement to the plan guide
	+ Example
```
--Create a query that forces optimizer to use index seek in the query
--create the following query
SELECT p.LastName, p.FirstName, HumanResources.Employee.JobTitle
FROM HumanResources.Employee
JOIN Person.Person AS p ON HumanResources.Employee.BusinessEntityID = p.BusinessEntityID
WHERE HumanResources.Employee.OrganizationLevel = 3 ORDER BY p.LastName, p.FirstName
--Create the Plan Guide
	 in statement: type in above statement
	 in type: SQL
	 in hints: OPTION (TABLE HINT(HumanResources.Employee, FORCESEEK))
--Create a SQL Profiler Trace
	Add in the Plan Guide Successful and Plan Guide Unsuccessful and click run
-- Switch back to the SSMS and Run Query
--Switch back to the Profiler and Pause query 
	verify you see Plan Guide Successful
	ensure that the query is provided in the same format, character-for-character, as it was specified in the plan guide statement. This includes tabs, spaces, carriage returns, or line feeds if the Plan Guide Unsuccessful happens.
```
	+ DMVs (Dynamic Management Views) DMOs
		- SQL Server 2005 and later
		- Troubleshoot performance related issues
		- Two types:
			+ DMVs:  work like views and you can select data from the DMV itself.
			+ DMF: values must be present to pass to the function and works like any other function.
	+ hints **overrides default behavior of Query optimizer:**
		- only as a last resort
		- 3 types:
			+ Join Hints
				- Enforces a join strategy you designate.
			+ Query Hints
				- used with OPTION
				- Affects all operators in statement
				- If used with UNION then only the last query can  have OPTION Clause (works on entire union)
				- If the hints cause the optimizer not to generate a valid plan, you will see **error 8622**
			+ Table Hints: 
				- Specified in the FROM Clause
				- Affects only the table or view in FROM
	+ Dynamic vs. parameterized queries
	+ Describe the different join types (HASH, MERGE, LOOP) and describe the scenarios they would be used in
		- HASH Join
			+ Default Join Type
			+ Tables not sorted and no indexes
			+ When no other way
			+ Example
``` 
SELECT
OC.FirstName, OC.LastName, OH.SalesOrderID
FROM
Sales.SalesOrderHeader AS OH
JOIN
Person.Contact AS OC
ON
OH.ContactID = OC.ContactID
WHERE
OC.FirstName LIKE 'John%'
OPTION (HASH JOIN)
``` 
		- MERGE Join
			+ Most efficient join between large tables
			+ both sets sorted on join key
```
SELECT
OC.FirstName, OC.LastName, OH.SalesOrderID
FROM
Sales.SalesOrderHeader AS OH
JOIN
Person.Contact AS OC
ON
OH.ContactID = OC.ContactID
WHERE
OC.FirstName LIKE 'John%'
OPTION (MERGE JOIN)
```
		- Nested Loops
			+ one table in join is much smaller than the other.
			+ Larger table has the join key.
```
SELECT
OC.FirstName, OC.LastName, OH.SalesOrderID
FROM
Sales.SalesOrderHeader AS OH
JOIN
Person.Contact AS OC
ON
OH.ContactID = OC.ContactID
WHERE
OC.FirstName LIKE 'John%'
OPTION (LOOP JOIN)
```