###Querying Microsoft SQL Server 2014 - Exam 70-461
{FileName}microsoft-sql70461-4-2-manage_transactions-MMDDYY
{EpisodeName}Manage Transactions
{ShowName}Querying Microsoft SQL Server 2014
{Description}
####4.0 Troubleshoot and optimize (25–30%)
* 4.2 Manage transactions
	+ Transactional Control ensures that the database integrit will not be compromised by partial transactions, service interruptions, interference from other transactions and constraint violations.
	+ Tranactions are complete and whole actions.  There are no partial transactions. 
	+ All changes in SQL Server database occur as transactions.
		- DML statements are transactions
		- DDL Statements are transactions
	+ Controlling transactions
		- commit: transaction approved by user, SQL server completes transaction.
		- rollback: User doesn't commit or unrecoverable error, the transaction is rolled back.
	+ Transactions Properties
		- **Atomicity** (complete success or nothing)
		- **Consistency** (all transactions--committed or rolled back leave the database in a consistent state)
		- **Isolation** (Transactions are isolated from others)
		- **Durability** (Transactions endure through interruption)
			- Committed transactions are completed
			- uncommitted transactions are rolled back.
	+ Mark a transaction
		- You can name a transaction but only the outermost transaction.
		- Names transactions used to mark the transaction log to locate a point in which a database can be restored.
	+ Understand begin tran, commit, and rollback
		- Every transaction begins with `BEGIN TRANSACTION` (BEGIN TRAN) and assigned name
		- End transaction by committing or rolling back
			+ commit: `COMMIT TRANSACTION` `COMMIT TRAN` or `COMMIT WORK` or `COMMIT`
			+ rollback: `ROLLBACK TRANSACTION` or `ROLLBACK TRAN` or `ROLLBACK WORK` or `ROLLBACK`
	+ Implicit
		- Implicit Transaction Mode: Issue DML or DDL or SELECT statement, the SQL server increments @@TRANCOUNT
		- Implicit doesn't automatically commit or roll back the statement.  You must run a `COMMIT` or `ROLLBACK` to complete transaction.
		- Implicit is not the default transaction mode 
		- `SET IMPLICIT_TRANSACTIONS ON;
		- Advantages:
			+ Rollback after command is completed
			+ easier to catch mistakes because you must commit manually.
		- Disadvantage:
			+ Possibly block others from accessing what you're using
			+ Must set per session
			+ can accidentally cause @@TRANCOUNT to 2
			+ If you forget to commit, you leave locks open
	+ Explicit transactions
		- When you explicitly run the `BEGIN TRANSACTION` to start a transaction
	+ Isolation levels
		- READ COMMITTED: Default level
			+ all readers will read data changes after committed
		- READ UNCOMMITTED: Read uncommitted data.
			+ Reading Dirty Data: results could be uncommitted data that was changed then later rolled back.
		- READ COMMITTED SNAPSHOT: Default in Azure SQL 
	
	+ @@Trancount